<?php
/**
 * Created by Luiz Filho
 */

namespace Model\Repository;

use Doctrine\ORM\EntityRepository;

class AF extends EntityRepository {

    public function retornaAFs($row) {
        $dataSet = array();
	  	$sql = "SELECT IAF.NRORG, IAF.CDFILDEST, IAF.CDFILLANC, IAF.NRAUTOFORN, IAF.CDPRODUTO, P.NMPRODUTO, P.SGUNIDADE,
                IAF.CDMARCA, M.NMMARCA, TO_CHAR(IAF.DTPROGENTAF, 'DD/MM/YYYY') AS DTPROGENTAF, NVL(IAF.VRPERDESAF, 0) AS VRPERDESAF, NVL(IAF.QTPROGENTAF, 0) AS QTPROGENTAF,
                NVL(IAF.VRPREUNIAF, 0) AS VRPREUNIAF, NVL(IAF.VRDESCITMAF, 0) AS VRDESCITMAF,
                ( ( NVL(IAF.QTPROGENTAF, 0) * NVL(IAF.VRPREUNIAF, 0) ) - NVL(IAF.VRDESCITMAF, 0) ) AS VRTOTALITEM
                FROM ITEMAUTF IAF
                JOIN (
                	/* RETORNA TODAS A NOTAS FICAIS DO PERIODO INFORMADO. PODE SER USADO PARA CRIAR O FILTRO POR NOTA FISCAL */
                	SELECT CDFILDEST, CDFILLANC, NRAUTOFORN, NRORG
                	FROM ITEMAUTF
                	WHERE CDFILDEST = :CDFILIAL
                	AND NRORG = :NRORG
                	AND DTPROGENTAF BETWEEN TO_DATE(:DATAINICIAL, 'DD/MM/YYYY') AND TO_DATE(:DATAFINAL, 'DD/MM/YYYY')
                	AND NVL(IDBAIXITMAF, '1') = '1'
                	GROUP BY CDFILDEST, CDFILLANC, NRAUTOFORN, NRORG
                	ORDER BY CDFILDEST, CDFILLANC, NRAUTOFORN, NRORG
                ) AF
                	ON AF.CDFILDEST = IAF.CDFILDEST
                	AND AF.CDFILLANC = IAF.CDFILLANC
                	AND AF.NRAUTOFORN = IAF.NRAUTOFORN
                	AND AF.NRORG = IAF.NRORG
                JOIN AUTOFORNE TAF 
                    ON AF.CDFILDEST = TAF.CDFILDEST
                    AND AF.CDFILLANC = TAF.CDFILLANC
                    AND AF.NRAUTOFORN = TAF.NRAUTOFORN
                    AND AF.NRORG = TAF.NRORG
                    AND NVL(TAF.IDBAIXAAF, '1') = '1'
                    AND NVL(TAF.IDAFEXPIRADA, 'N') = 'N'
                JOIN PRODUTO P ON P.CDPRODUTO = IAF.CDPRODUTO AND P.NRORG = IAF.NRORG
                JOIN MARCA M ON M.CDMARCA = IAF.CDMARCA AND M.NRORG = IAF.NRORG
                ORDER BY DTPROGENTAF, IAF.NRAUTOFORN, IAF.CDFILDEST, IAF.CDFILLANC, P.NMPRODUTO";

	  	$params = array(
		    'NRORG' => $row['NRORG'],
            'DATAINICIAL' => $row['DATAINICIAL'],
            'DATAFINAL' => $row['DATAFINAL'],
            'CDFILIAL' => ''
		);

        foreach ($row['FILIAIS'] as $filial) {
            $params['CDFILIAL'] = $filial;
            $query = $this->getEntityManager()->getConnection()->prepare($sql);
            $query->execute($params);
            $dataSet = array_merge($dataSet, $query->fetchAll());
        }
        return $dataSet;
    }
}